/* 
 * Copyright (c) 1993-2010 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef VIAM_PRINT_H
#define VIAM_PRINT_H


/* Structures definies par d'autres modules */

#include "server/tclservClient/pomTclservClientEncode.h"


#include "server/viamPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
void buf_add_struct_ViamIDS ( buf_t buf, struct ViamIDS *x, int nDim, int *dims);
void buf_add_struct_ViamImageBank ( buf_t buf, struct ViamImageBank *x, int nDim, int *dims);
void buf_add_struct_ViamImageHeader ( buf_t buf, struct ViamImageHeader *x, int nDim, int *dims);
void buf_add_struct_ViamSave ( buf_t buf, struct ViamSave *x, int nDim, int *dims);
void buf_add_struct_ViamDisplay ( buf_t buf, struct ViamDisplay *x, int nDim, int *dims);
void buf_add_struct_ViamCalibrationIO ( buf_t buf, struct ViamCalibrationIO *x, int nDim, int *dims);
void buf_add_struct_ViamCalibrate ( buf_t buf, struct ViamCalibrate *x, int nDim, int *dims);
void buf_add_struct_ViamUMiscFilter ( buf_t buf, struct ViamUMiscFilter *x, int nDim, int *dims);
void buf_add_struct_ViamMiscFilter ( buf_t buf, struct ViamMiscFilter *x, int nDim, int *dims);
void buf_add_enum_ViamMiscFilterType ( buf_t buf, enum ViamMiscFilterType *x, int nDim, int *dims);
void buf_add_struct_ViamUPxFilter ( buf_t buf, struct ViamUPxFilter *x, int nDim, int *dims);
void buf_add_struct_ViamPxFilter ( buf_t buf, struct ViamPxFilter *x, int nDim, int *dims);
void buf_add_enum_ViamPxFilterType ( buf_t buf, enum ViamPxFilterType *x, int nDim, int *dims);
void buf_add_struct_ViamUColorFilter ( buf_t buf, struct ViamUColorFilter *x, int nDim, int *dims);
void buf_add_struct_ViamColorFilter ( buf_t buf, struct ViamColorFilter *x, int nDim, int *dims);
void buf_add_enum_ViamColorFilterType ( buf_t buf, enum ViamColorFilterType *x, int nDim, int *dims);
void buf_add_struct_ViamULumFilter ( buf_t buf, struct ViamULumFilter *x, int nDim, int *dims);
void buf_add_struct_ViamLumFilter ( buf_t buf, struct ViamLumFilter *x, int nDim, int *dims);
void buf_add_enum_ViamLumFilterType ( buf_t buf, enum ViamLumFilterType *x, int nDim, int *dims);
void buf_add_struct_ViamUGeoFilter ( buf_t buf, struct ViamUGeoFilter *x, int nDim, int *dims);
void buf_add_struct_ViamGeoFilter ( buf_t buf, struct ViamGeoFilter *x, int nDim, int *dims);
void buf_add_enum_ViamGeoFilterType ( buf_t buf, enum ViamGeoFilterType *x, int nDim, int *dims);
void buf_add_struct_ViamUFmtFilter ( buf_t buf, struct ViamUFmtFilter *x, int nDim, int *dims);
void buf_add_struct_ViamFmtFilter ( buf_t buf, struct ViamFmtFilter *x, int nDim, int *dims);
void buf_add_enum_ViamFmtFilterType ( buf_t buf, enum ViamFmtFilterType *x, int nDim, int *dims);
void buf_add_struct_ViamFilterList ( buf_t buf, struct ViamFilterList *x, int nDim, int *dims);
void buf_add_struct_ViamFilterGetCap ( buf_t buf, struct ViamFilterGetCap *x, int nDim, int *dims);
void buf_add_struct_ViamFilterCap ( buf_t buf, struct ViamFilterCap *x, int nDim, int *dims);
void buf_add_struct_ViamAcquire ( buf_t buf, struct ViamAcquire *x, int nDim, int *dims);
void buf_add_struct_ViamHWMode ( buf_t buf, struct ViamHWMode *x, int nDim, int *dims);
void buf_add_struct_ViamHWModeList ( buf_t buf, struct ViamHWModeList *x, int nDim, int *dims);
void buf_add_struct_ViamHWModeListOffset ( buf_t buf, struct ViamHWModeListOffset *x, int nDim, int *dims);
void buf_add_struct_ViamBankAddCamera ( buf_t buf, struct ViamBankAddCamera *x, int nDim, int *dims);
void buf_add_struct_ViamCameraCreate ( buf_t buf, struct ViamCameraCreate *x, int nDim, int *dims);
void buf_add_struct_ViamBankCreate ( buf_t buf, struct ViamBankCreate *x, int nDim, int *dims);
void buf_add_enum_ViamImageUpdate ( buf_t buf, enum ViamImageUpdate *x, int nDim, int *dims);
void buf_add_enum_ViamActivate ( buf_t buf, enum ViamActivate *x, int nDim, int *dims);
void buf_add_enum_ViamIO ( buf_t buf, enum ViamIO *x, int nDim, int *dims);
void buf_add_struct_ViamId ( buf_t buf, struct ViamId *x, int nDim, int *dims);
void buf_add_struct_viam_bankcalibration_t ( buf_t buf, struct viam_bankcalibration_t *x, int nDim, int *dims);
void buf_add_struct_viam_cameracalibration_t ( buf_t buf, struct viam_cameracalibration_t *x, int nDim, int *dims);
void buf_add_enum_viam_distortionmodel_t ( buf_t buf, enum viam_distortionmodel_t *x, int nDim, int *dims);
void buf_add_enum_viam_caltype_t ( buf_t buf, enum viam_caltype_t *x, int nDim, int *dims);
void buf_add_struct_viam_geometry_t ( buf_t buf, struct viam_geometry_t *x, int nDim, int *dims);
void buf_add_enum_viam_filterautomode_t ( buf_t buf, enum viam_filterautomode_t *x, int nDim, int *dims);
void buf_add_enum_viam_filtermethod_t ( buf_t buf, enum viam_filtermethod_t *x, int nDim, int *dims);
void buf_add_enum_viam_valuekind_t ( buf_t buf, enum viam_valuekind_t *x, int nDim, int *dims);
void buf_add_enum_viam_filterformat_t ( buf_t buf, enum viam_filterformat_t *x, int nDim, int *dims);
void buf_add_enum_viam_filtertype_t ( buf_t buf, enum viam_filtertype_t *x, int nDim, int *dims);
void buf_add_struct_viam_hwmode_t ( buf_t buf, struct viam_hwmode_t *x, int nDim, int *dims);
void buf_add_enum_viam_hwtrigger_t ( buf_t buf, enum viam_hwtrigger_t *x, int nDim, int *dims);
void buf_add_enum_viam_hwfps_t ( buf_t buf, enum viam_hwfps_t *x, int nDim, int *dims);
void buf_add_enum_viam_hwformat_t ( buf_t buf, enum viam_hwformat_t *x, int nDim, int *dims);
void buf_add_enum_viam_hwsize_t ( buf_t buf, enum viam_hwsize_t *x, int nDim, int *dims);
void buf_add_enum_viam_hwcrop_t ( buf_t buf, enum viam_hwcrop_t *x, int nDim, int *dims);
void buf_add_enum_viam_errorcode_t ( buf_t buf, enum viam_errorcode_t *x, int nDim, int *dims);
void buf_add_enum_viam_onoff_t ( buf_t buf, enum viam_onoff_t *x, int nDim, int *dims);

/* ======================== PRINT DES TYPEDEF ============================= */

void buf_add_viam_onoff_t ( buf_t buf, viam_onoff_t *x, int nDim, int *dims);
void buf_add_viam_errorcode_t ( buf_t buf, viam_errorcode_t *x, int nDim, int *dims);
void buf_add_viam_hwcrop_t ( buf_t buf, viam_hwcrop_t *x, int nDim, int *dims);
void buf_add_viam_hwsize_t ( buf_t buf, viam_hwsize_t *x, int nDim, int *dims);
void buf_add_viam_hwformat_t ( buf_t buf, viam_hwformat_t *x, int nDim, int *dims);
void buf_add_viam_hwfps_t ( buf_t buf, viam_hwfps_t *x, int nDim, int *dims);
void buf_add_viam_hwtrigger_t ( buf_t buf, viam_hwtrigger_t *x, int nDim, int *dims);
void buf_add_viam_hwmode_t ( buf_t buf, viam_hwmode_t *x, int nDim, int *dims);
void buf_add_viam_filtertype_t ( buf_t buf, viam_filtertype_t *x, int nDim, int *dims);
void buf_add_viam_filterformat_t ( buf_t buf, viam_filterformat_t *x, int nDim, int *dims);
void buf_add_viam_valuekind_t ( buf_t buf, viam_valuekind_t *x, int nDim, int *dims);
void buf_add_viam_filtermethod_t ( buf_t buf, viam_filtermethod_t *x, int nDim, int *dims);
void buf_add_viam_filterautomode_t ( buf_t buf, viam_filterautomode_t *x, int nDim, int *dims);
void buf_add_viam_geometry_t ( buf_t buf, viam_geometry_t *x, int nDim, int *dims);
void buf_add_viam_caltype_t ( buf_t buf, viam_caltype_t *x, int nDim, int *dims);
void buf_add_viam_distortionmodel_t ( buf_t buf, viam_distortionmodel_t *x, int nDim, int *dims);
void buf_add_viam_cameracalibration_t ( buf_t buf, viam_cameracalibration_t *x, int nDim, int *dims);
void buf_add_viam_bankcalibration_t ( buf_t buf, viam_bankcalibration_t *x, int nDim, int *dims);
void buf_add_ViamId ( buf_t buf, ViamId *x, int nDim, int *dims);
void buf_add_ViamIO ( buf_t buf, ViamIO *x, int nDim, int *dims);
void buf_add_ViamActivate ( buf_t buf, ViamActivate *x, int nDim, int *dims);
void buf_add_ViamImageUpdate ( buf_t buf, ViamImageUpdate *x, int nDim, int *dims);
void buf_add_ViamBankCreate ( buf_t buf, ViamBankCreate *x, int nDim, int *dims);
void buf_add_ViamCameraCreate ( buf_t buf, ViamCameraCreate *x, int nDim, int *dims);
void buf_add_ViamBankAddCamera ( buf_t buf, ViamBankAddCamera *x, int nDim, int *dims);
void buf_add_ViamHWModeListOffset ( buf_t buf, ViamHWModeListOffset *x, int nDim, int *dims);
void buf_add_ViamHWModeList ( buf_t buf, ViamHWModeList *x, int nDim, int *dims);
void buf_add_ViamHWMode ( buf_t buf, ViamHWMode *x, int nDim, int *dims);
void buf_add_ViamAcquire ( buf_t buf, ViamAcquire *x, int nDim, int *dims);
void buf_add_ViamFilterCap ( buf_t buf, ViamFilterCap *x, int nDim, int *dims);
void buf_add_ViamFilterGetCap ( buf_t buf, ViamFilterGetCap *x, int nDim, int *dims);
void buf_add_ViamFilterList ( buf_t buf, ViamFilterList *x, int nDim, int *dims);
void buf_add_ViamFmtFilterType ( buf_t buf, ViamFmtFilterType *x, int nDim, int *dims);
void buf_add_ViamFmtFilter ( buf_t buf, ViamFmtFilter *x, int nDim, int *dims);
void buf_add_ViamUFmtFilter ( buf_t buf, ViamUFmtFilter *x, int nDim, int *dims);
void buf_add_ViamGeoFilterType ( buf_t buf, ViamGeoFilterType *x, int nDim, int *dims);
void buf_add_ViamGeoFilter ( buf_t buf, ViamGeoFilter *x, int nDim, int *dims);
void buf_add_ViamUGeoFilter ( buf_t buf, ViamUGeoFilter *x, int nDim, int *dims);
void buf_add_ViamLumFilterType ( buf_t buf, ViamLumFilterType *x, int nDim, int *dims);
void buf_add_ViamLumFilter ( buf_t buf, ViamLumFilter *x, int nDim, int *dims);
void buf_add_ViamULumFilter ( buf_t buf, ViamULumFilter *x, int nDim, int *dims);
void buf_add_ViamColorFilterType ( buf_t buf, ViamColorFilterType *x, int nDim, int *dims);
void buf_add_ViamColorFilter ( buf_t buf, ViamColorFilter *x, int nDim, int *dims);
void buf_add_ViamUColorFilter ( buf_t buf, ViamUColorFilter *x, int nDim, int *dims);
void buf_add_ViamPxFilterType ( buf_t buf, ViamPxFilterType *x, int nDim, int *dims);
void buf_add_ViamPxFilter ( buf_t buf, ViamPxFilter *x, int nDim, int *dims);
void buf_add_ViamUPxFilter ( buf_t buf, ViamUPxFilter *x, int nDim, int *dims);
void buf_add_ViamMiscFilterType ( buf_t buf, ViamMiscFilterType *x, int nDim, int *dims);
void buf_add_ViamMiscFilter ( buf_t buf, ViamMiscFilter *x, int nDim, int *dims);
void buf_add_ViamUMiscFilter ( buf_t buf, ViamUMiscFilter *x, int nDim, int *dims);
void buf_add_ViamCalibrate ( buf_t buf, ViamCalibrate *x, int nDim, int *dims);
void buf_add_ViamCalibrationIO ( buf_t buf, ViamCalibrationIO *x, int nDim, int *dims);
void buf_add_ViamDisplay ( buf_t buf, ViamDisplay *x, int nDim, int *dims);
void buf_add_ViamSave ( buf_t buf, ViamSave *x, int nDim, int *dims);
void buf_add_ViamImageHeader ( buf_t buf, ViamImageHeader *x, int nDim, int *dims);
void buf_add_ViamImageBank ( buf_t buf, ViamImageBank *x, int nDim, int *dims);
void buf_add_ViamIDS ( buf_t buf, ViamIDS *x, int nDim, int *dims);
#ifdef __cplusplus
}
#endif

#endif /* VIAM_TCLSERV_CLIENT_ENCODE_H */

