
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef VIAM_PRINTXML_H
#define VIAM_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/pomPrintXML.h"


#include "viamPosterLib.h"

/* Prototypes */
extern void printXML_struct_ViamIDS ( FILE *out, char *name,
     struct ViamIDS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamImageBank ( FILE *out, char *name,
     struct ViamImageBank *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamImageHeader ( FILE *out, char *name,
     struct ViamImageHeader *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamSave ( FILE *out, char *name,
     struct ViamSave *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamDisplay ( FILE *out, char *name,
     struct ViamDisplay *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamCalibrationIO ( FILE *out, char *name,
     struct ViamCalibrationIO *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamCalibrate ( FILE *out, char *name,
     struct ViamCalibrate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamUMiscFilter ( FILE *out, char *name,
     struct ViamUMiscFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamMiscFilter ( FILE *out, char *name,
     struct ViamMiscFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamMiscFilterType ( FILE *out, char *name,
     enum ViamMiscFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamUPxFilter ( FILE *out, char *name,
     struct ViamUPxFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamPxFilter ( FILE *out, char *name,
     struct ViamPxFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamPxFilterType ( FILE *out, char *name,
     enum ViamPxFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamUColorFilter ( FILE *out, char *name,
     struct ViamUColorFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamColorFilter ( FILE *out, char *name,
     struct ViamColorFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamColorFilterType ( FILE *out, char *name,
     enum ViamColorFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamULumFilter ( FILE *out, char *name,
     struct ViamULumFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamLumFilter ( FILE *out, char *name,
     struct ViamLumFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamLumFilterType ( FILE *out, char *name,
     enum ViamLumFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamUGeoFilter ( FILE *out, char *name,
     struct ViamUGeoFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamGeoFilter ( FILE *out, char *name,
     struct ViamGeoFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamGeoFilterType ( FILE *out, char *name,
     enum ViamGeoFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamUFmtFilter ( FILE *out, char *name,
     struct ViamUFmtFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamFmtFilter ( FILE *out, char *name,
     struct ViamFmtFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamFmtFilterType ( FILE *out, char *name,
     enum ViamFmtFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamFilterList ( FILE *out, char *name,
     struct ViamFilterList *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamFilterGetCap ( FILE *out, char *name,
     struct ViamFilterGetCap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamFilterCap ( FILE *out, char *name,
     struct ViamFilterCap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamAcquire ( FILE *out, char *name,
     struct ViamAcquire *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamHWMode ( FILE *out, char *name,
     struct ViamHWMode *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamHWModeList ( FILE *out, char *name,
     struct ViamHWModeList *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamHWModeListOffset ( FILE *out, char *name,
     struct ViamHWModeListOffset *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamBankAddCamera ( FILE *out, char *name,
     struct ViamBankAddCamera *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamCameraCreate ( FILE *out, char *name,
     struct ViamCameraCreate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamBankCreate ( FILE *out, char *name,
     struct ViamBankCreate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamImageUpdate ( FILE *out, char *name,
     enum ViamImageUpdate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamActivate ( FILE *out, char *name,
     enum ViamActivate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ViamIO ( FILE *out, char *name,
     enum ViamIO *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ViamId ( FILE *out, char *name,
     struct ViamId *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_viam_bankcalibration_t ( FILE *out, char *name,
     struct viam_bankcalibration_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_viam_cameracalibration_t ( FILE *out, char *name,
     struct viam_cameracalibration_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_distortionmodel_t ( FILE *out, char *name,
     enum viam_distortionmodel_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_caltype_t ( FILE *out, char *name,
     enum viam_caltype_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_viam_geometry_t ( FILE *out, char *name,
     struct viam_geometry_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_filterautomode_t ( FILE *out, char *name,
     enum viam_filterautomode_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_filtermethod_t ( FILE *out, char *name,
     enum viam_filtermethod_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_valuekind_t ( FILE *out, char *name,
     enum viam_valuekind_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_filterformat_t ( FILE *out, char *name,
     enum viam_filterformat_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_filtertype_t ( FILE *out, char *name,
     enum viam_filtertype_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_viam_hwmode_t ( FILE *out, char *name,
     struct viam_hwmode_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_hwtrigger_t ( FILE *out, char *name,
     enum viam_hwtrigger_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_hwfps_t ( FILE *out, char *name,
     enum viam_hwfps_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_hwformat_t ( FILE *out, char *name,
     enum viam_hwformat_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_hwsize_t ( FILE *out, char *name,
     enum viam_hwsize_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_hwcrop_t ( FILE *out, char *name,
     enum viam_hwcrop_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_errorcode_t ( FILE *out, char *name,
     enum viam_errorcode_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_viam_onoff_t ( FILE *out, char *name,
     enum viam_onoff_t *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_viam_onoff_t ( FILE *out, char *name,
     viam_onoff_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_errorcode_t ( FILE *out, char *name,
     viam_errorcode_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_hwcrop_t ( FILE *out, char *name,
     viam_hwcrop_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_hwsize_t ( FILE *out, char *name,
     viam_hwsize_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_hwformat_t ( FILE *out, char *name,
     viam_hwformat_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_hwfps_t ( FILE *out, char *name,
     viam_hwfps_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_hwtrigger_t ( FILE *out, char *name,
     viam_hwtrigger_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_hwmode_t ( FILE *out, char *name,
     viam_hwmode_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_filtertype_t ( FILE *out, char *name,
     viam_filtertype_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_filterformat_t ( FILE *out, char *name,
     viam_filterformat_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_valuekind_t ( FILE *out, char *name,
     viam_valuekind_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_filtermethod_t ( FILE *out, char *name,
     viam_filtermethod_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_filterautomode_t ( FILE *out, char *name,
     viam_filterautomode_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_geometry_t ( FILE *out, char *name,
     viam_geometry_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_caltype_t ( FILE *out, char *name,
     viam_caltype_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_distortionmodel_t ( FILE *out, char *name,
     viam_distortionmodel_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_cameracalibration_t ( FILE *out, char *name,
     viam_cameracalibration_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_viam_bankcalibration_t ( FILE *out, char *name,
     viam_bankcalibration_t *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamId ( FILE *out, char *name,
     ViamId *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamIO ( FILE *out, char *name,
     ViamIO *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamActivate ( FILE *out, char *name,
     ViamActivate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamImageUpdate ( FILE *out, char *name,
     ViamImageUpdate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamBankCreate ( FILE *out, char *name,
     ViamBankCreate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamCameraCreate ( FILE *out, char *name,
     ViamCameraCreate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamBankAddCamera ( FILE *out, char *name,
     ViamBankAddCamera *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamHWModeListOffset ( FILE *out, char *name,
     ViamHWModeListOffset *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamHWModeList ( FILE *out, char *name,
     ViamHWModeList *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamHWMode ( FILE *out, char *name,
     ViamHWMode *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamAcquire ( FILE *out, char *name,
     ViamAcquire *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamFilterCap ( FILE *out, char *name,
     ViamFilterCap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamFilterGetCap ( FILE *out, char *name,
     ViamFilterGetCap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamFilterList ( FILE *out, char *name,
     ViamFilterList *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamFmtFilterType ( FILE *out, char *name,
     ViamFmtFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamFmtFilter ( FILE *out, char *name,
     ViamFmtFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamUFmtFilter ( FILE *out, char *name,
     ViamUFmtFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamGeoFilterType ( FILE *out, char *name,
     ViamGeoFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamGeoFilter ( FILE *out, char *name,
     ViamGeoFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamUGeoFilter ( FILE *out, char *name,
     ViamUGeoFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamLumFilterType ( FILE *out, char *name,
     ViamLumFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamLumFilter ( FILE *out, char *name,
     ViamLumFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamULumFilter ( FILE *out, char *name,
     ViamULumFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamColorFilterType ( FILE *out, char *name,
     ViamColorFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamColorFilter ( FILE *out, char *name,
     ViamColorFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamUColorFilter ( FILE *out, char *name,
     ViamUColorFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamPxFilterType ( FILE *out, char *name,
     ViamPxFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamPxFilter ( FILE *out, char *name,
     ViamPxFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamUPxFilter ( FILE *out, char *name,
     ViamUPxFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamMiscFilterType ( FILE *out, char *name,
     ViamMiscFilterType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamMiscFilter ( FILE *out, char *name,
     ViamMiscFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamUMiscFilter ( FILE *out, char *name,
     ViamUMiscFilter *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamCalibrate ( FILE *out, char *name,
     ViamCalibrate *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamCalibrationIO ( FILE *out, char *name,
     ViamCalibrationIO *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamDisplay ( FILE *out, char *name,
     ViamDisplay *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamSave ( FILE *out, char *name,
     ViamSave *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamImageHeader ( FILE *out, char *name,
     ViamImageHeader *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamImageBank ( FILE *out, char *name,
     ViamImageBank *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ViamIDS ( FILE *out, char *name,
     ViamIDS *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* VIAM_PRINT_XML_H */

