
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] viamInstall] >= 0 } {
    interp expose {} viamInstall
}

proc ::viamInstall { name } {
    foreach rqst { "Init" "Configure" "Reset" "DriverLoad" "BusPrint" "BankCreate" "CameraCreate" "BankAddCamera" "PushFormatFilter" "UpdateFormatFilter" "PushGeoFilter" "UpdateGeoFilter" "PushLumFilter" "UpdateLumFilter" "PushColorFilter" "UpdateColorFilter" "PushImProcFilter" "UpdateImProcFilter" "PushMiscFilter" "UpdateMiscFilter" "FilterList" "FilterGetCap" "CameraListHWModes" "CameraSetHWMode" "Acquire" "Stop" "Display" "Calibrate" "CalibrationIO" "Save"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} viam$rqst $name
    }
}

interp hide {} viamInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] viamInit] >= 0 } {
    interp expose {} viamInit
}
if { [lsearch [interp hidden] viamInitFormatOutput] >= 0 } {
    interp expose {} viamInitFormatOutput
}

proc ::viamInit { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Init" \
	"Look for camera nodes and configure module" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::viamInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamInit
interp hide {} viamInitFormatOutput





# Configure ----------------------------------------------------------

if { [lsearch [interp hidden] viamConfigure] >= 0 } {
    interp expose {} viamConfigure
}
if { [lsearch [interp hidden] viamConfigureFormatOutput] >= 0 } {
    interp expose {} viamConfigureFormatOutput
}

proc ::viamConfigure { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]

    return [ ::cs::rqstSend "${name}" "Configure" \
	"Configure a bank for image acquisition" \
	"ViamId\n| char id\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::viamConfigureFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamConfigure
interp hide {} viamConfigureFormatOutput





# Reset ----------------------------------------------------------

if { [lsearch [interp hidden] viamReset] >= 0 } {
    interp expose {} viamReset
}
if { [lsearch [interp hidden] viamResetFormatOutput] >= 0 } {
    interp expose {} viamResetFormatOutput
}

proc ::viamReset { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Reset" \
	"Stop module and reset configuration info" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::viamResetFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamReset
interp hide {} viamResetFormatOutput





# DriverLoad ----------------------------------------------------------

if { [lsearch [interp hidden] viamDriverLoad] >= 0 } {
    interp expose {} viamDriverLoad
}
if { [lsearch [interp hidden] viamDriverLoadFormatOutput] >= 0 } {
    interp expose {} viamDriverLoadFormatOutput
}

proc ::viamDriverLoad { name args } {
    set format {}
    lappend format [list string "Driver name" "" ]

    return [ ::cs::rqstSend "${name}" "DriverLoad" \
	"Load an acquisition driver" \
	"ViamId\n| char id\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::viamDriverLoadFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamDriverLoad
interp hide {} viamDriverLoadFormatOutput





# BusPrint ----------------------------------------------------------

if { [lsearch [interp hidden] viamBusPrint] >= 0 } {
    interp expose {} viamBusPrint
}
if { [lsearch [interp hidden] viamBusPrintFormatOutput] >= 0 } {
    interp expose {} viamBusPrintFormatOutput
}

proc ::viamBusPrint { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "BusPrint" \
	"List firewire camera devices on stdout" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::viamBusPrintFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamBusPrint
interp hide {} viamBusPrintFormatOutput





# BankCreate ----------------------------------------------------------

if { [lsearch [interp hidden] viamBankCreate] >= 0 } {
    interp expose {} viamBankCreate
}
if { [lsearch [interp hidden] viamBankCreateFormatOutput] >= 0 } {
    interp expose {} viamBankCreateFormatOutput
}

proc ::viamBankCreate { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]
    lappend format [list { "VIAM_DOUBLE_BUFFERING" "VIAM_SINGLE_BUFFERING" } "Poster updating method" "VIAM_DOUBLE_BUFFERING" ]
    lappend format [list { "VIAM_ENABLE" "VIAM_DISABLE" } "Tag image position with pom" "VIAM_DISABLE" ]

    return [ ::cs::rqstSend "${name}" "BankCreate" \
	"Add a bank to the module configuration" \
	"ViamBankCreate\n| ViamId\n| | char id\[64\]\n| ViamImageUpdate buffering\n| ViamActivate tags\n" \
	3 \
	$format \
	$args ]
}


proc ::viamBankCreateFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamBankCreate
interp hide {} viamBankCreateFormatOutput





# CameraCreate ----------------------------------------------------------

if { [lsearch [interp hidden] viamCameraCreate] >= 0 } {
    interp expose {} viamCameraCreate
}
if { [lsearch [interp hidden] viamCameraCreateFormatOutput] >= 0 } {
    interp expose {} viamCameraCreateFormatOutput
}

proc ::viamCameraCreate { name args } {
    set format {}
    lappend format [list string "Camera local name" "" ]
    lappend format [list string "Camera unique id (64bits)" "" ]

    return [ ::cs::rqstSend "${name}" "CameraCreate" \
	"Add a camera to the module configuration" \
	"ViamCameraCreate\n| ViamId\n| | char id\[64\]\n| char uid\[1024\]\n" \
	2 \
	$format \
	$args ]
}


proc ::viamCameraCreateFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamCameraCreate
interp hide {} viamCameraCreateFormatOutput





# BankAddCamera ----------------------------------------------------------

if { [lsearch [interp hidden] viamBankAddCamera] >= 0 } {
    interp expose {} viamBankAddCamera
}
if { [lsearch [interp hidden] viamBankAddCameraFormatOutput] >= 0 } {
    interp expose {} viamBankAddCameraFormatOutput
}

proc ::viamBankAddCamera { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]
    lappend format [list string "Camera name" "" ]
    lappend format [list string "Image name" "" ]

    return [ ::cs::rqstSend "${name}" "BankAddCamera" \
	"Attach an existing camera to a bank" \
	"ViamBankAddCamera\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n" \
	3 \
	$format \
	$args ]
}


proc ::viamBankAddCameraFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamBankAddCamera
interp hide {} viamBankAddCameraFormatOutput





# PushFormatFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamPushFormatFilter] >= 0 } {
    interp expose {} viamPushFormatFilter
}
if { [lsearch [interp hidden] viamPushFormatFilterFormatOutput] >= 0 } {
    interp expose {} viamPushFormatFilterFormatOutput
}

proc ::viamPushFormatFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list string "Image name" "" ]
    lappend format [list { "VIAM_FMTFILTER_FORMAT" } "Filter type" "VIAM_FMTFILTER_FORMAT" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_SOFTWARE" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter values" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_FILTER_BAYER_DECIM_GBRG" "VIAM_FILTER_BAYER_DECIM_RGGB" "VIAM_FILTER_BAYER_DECIM_GRBG" "VIAM_FILTER_BAYER_DECIM_BGGR" "VIAM_FILTER_BAYER_NN_GBRG" "VIAM_FILTER_BAYER_NN_RGGB" "VIAM_FILTER_BAYER_NN_GRBG" "VIAM_FILTER_BAYER_NN_BGGR" "VIAM_FILTER_YUV444_TO_BGR" "VIAM_FILTER_YUV411_TO_BGR" "VIAM_FILTER_YVU422_YVYU_TO_BGR" "VIAM_FILTER_YVU422_VYUY_TO_BGR" "VIAM_FILTER_YUV422_YYUV_TO_BGR" "VIAM_FILTER_YUV422_YUYV_TO_BGR" "VIAM_FILTER_YUV422_UYVY_TO_BGR" "VIAM_FILTER_BGR_TO_GRAY" "VIAM_FILTER_RGB_TO_GRAY" "VIAM_FILTER_RGB_TO_BGR" "VIAM_FILTER_BAYER_GBRG" "VIAM_FILTER_BAYER_RGGB" "VIAM_FILTER_BAYER_GRBG" "VIAM_FILTER_BAYER_BGGR" "VIAM_FILTER_DEMUX_ODDPX" "VIAM_FILTER_DEMUX_EVENPX" } "Image format conversion" "VIAM_FILTER_BAYER_BGGR" ]

    return [ ::cs::rqstSend "${name}" "PushFormatFilter" \
	"Push additional format filter" \
	"ViamFmtFilter\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| ViamFmtFilterType type\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_filterformat_t format\n" \
	6 \
	$format \
	$args ]
}


proc ::viamPushFormatFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamPushFormatFilter
interp hide {} viamPushFormatFilterFormatOutput





# UpdateFormatFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamUpdateFormatFilter] >= 0 } {
    interp expose {} viamUpdateFormatFilter
}
if { [lsearch [interp hidden] viamUpdateFormatFilterFormatOutput] >= 0 } {
    interp expose {} viamUpdateFormatFilterFormatOutput
}

proc ::viamUpdateFormatFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_SOFTWARE" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter values" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_FILTER_BAYER_DECIM_GBRG" "VIAM_FILTER_BAYER_DECIM_RGGB" "VIAM_FILTER_BAYER_DECIM_GRBG" "VIAM_FILTER_BAYER_DECIM_BGGR" "VIAM_FILTER_BAYER_NN_GBRG" "VIAM_FILTER_BAYER_NN_RGGB" "VIAM_FILTER_BAYER_NN_GRBG" "VIAM_FILTER_BAYER_NN_BGGR" "VIAM_FILTER_YUV444_TO_BGR" "VIAM_FILTER_YUV411_TO_BGR" "VIAM_FILTER_YVU422_YVYU_TO_BGR" "VIAM_FILTER_YVU422_VYUY_TO_BGR" "VIAM_FILTER_YUV422_YYUV_TO_BGR" "VIAM_FILTER_YUV422_YUYV_TO_BGR" "VIAM_FILTER_YUV422_UYVY_TO_BGR" "VIAM_FILTER_BGR_TO_GRAY" "VIAM_FILTER_RGB_TO_GRAY" "VIAM_FILTER_RGB_TO_BGR" "VIAM_FILTER_BAYER_GBRG" "VIAM_FILTER_BAYER_RGGB" "VIAM_FILTER_BAYER_GRBG" "VIAM_FILTER_BAYER_BGGR" "VIAM_FILTER_DEMUX_ODDPX" "VIAM_FILTER_DEMUX_EVENPX" } "Image format conversion" "VIAM_FILTER_YUV422_UYVY_TO_BGR" ]

    return [ ::cs::rqstSend "${name}" "UpdateFormatFilter" \
	"Update existing format filter" \
	"ViamUFmtFilter\n| ViamId\n| | char id\[64\]\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_filterformat_t format\n" \
	4 \
	$format \
	$args ]
}


proc ::viamUpdateFormatFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamUpdateFormatFilter
interp hide {} viamUpdateFormatFilterFormatOutput





# PushGeoFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamPushGeoFilter] >= 0 } {
    interp expose {} viamPushGeoFilter
}
if { [lsearch [interp hidden] viamPushGeoFilterFormatOutput] >= 0 } {
    interp expose {} viamPushGeoFilterFormatOutput
}

proc ::viamPushGeoFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list string "Image name" "" ]
    lappend format [list { "VIAM_GEOFILTER_SCALE" "VIAM_GEOFILTER_SUBSAMPLE" "VIAM_GEOFILTER_RECTIFY_NN" "VIAM_GEOFILTER_RECTIFY" "VIAM_GEOFILTER_DISTORT_NN" "VIAM_GEOFILTER_DISTORT" } "Filter type" "VIAM_GEOFILTER_SUBSAMPLE" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_SOFTWARE" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter values" "VIAM_FILTER_MANUAL" ]
    lappend format [list double "Left (in percent if <=1.0) " 0.000000 ]
    lappend format [list double "Top (in percent if <=1.0)" 0.000000 ]
    lappend format [list double "Bottom (in percent if <=1.0) " 0.000000 ]
    lappend format [list double "Right (in percent if <=1.0)" 0.000000 ]
    lappend format [list double "Desired width (in percent of original if <=1.0) " 1.000000 ]
    lappend format [list double "Desired height (in percent of original if <=1.0)" 1.000000 ]

    return [ ::cs::rqstSend "${name}" "PushGeoFilter" \
	"Push additional geometry filter" \
	"ViamGeoFilter\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| ViamGeoFilterType type\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| double left\n| double top\n| double right\n| double bottom\n| double toWidth\n| double toHeight\n" \
	11 \
	$format \
	$args ]
}


proc ::viamPushGeoFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamPushGeoFilter
interp hide {} viamPushGeoFilterFormatOutput





# UpdateGeoFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamUpdateGeoFilter] >= 0 } {
    interp expose {} viamUpdateGeoFilter
}
if { [lsearch [interp hidden] viamUpdateGeoFilterFormatOutput] >= 0 } {
    interp expose {} viamUpdateGeoFilterFormatOutput
}

proc ::viamUpdateGeoFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_SOFTWARE" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter values" "VIAM_FILTER_MANUAL" ]
    lappend format [list double "Left (in percent if <=1.0) " 0.000000 ]
    lappend format [list double "Top (in percent if <=1.0)" 0.000000 ]
    lappend format [list double "Bottom (in percent if <=1.0) " 0.000000 ]
    lappend format [list double "Right (in percent if <=1.0)" 0.000000 ]
    lappend format [list double "Desired width (in percent of original if <=1.0) " 1.000000 ]
    lappend format [list double "Desired height (in percent of original if <=1.0)" 1.000000 ]

    return [ ::cs::rqstSend "${name}" "UpdateGeoFilter" \
	"Update existing geometry filter" \
	"ViamUGeoFilter\n| ViamId\n| | char id\[64\]\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| double left\n| double top\n| double right\n| double bottom\n| double toWidth\n| double toHeight\n" \
	9 \
	$format \
	$args ]
}


proc ::viamUpdateGeoFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamUpdateGeoFilter
interp hide {} viamUpdateGeoFilterFormatOutput





# PushLumFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamPushLumFilter] >= 0 } {
    interp expose {} viamPushLumFilter
}
if { [lsearch [interp hidden] viamPushLumFilterFormatOutput] >= 0 } {
    interp expose {} viamPushLumFilterFormatOutput
}

proc ::viamPushLumFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list string "Image name" "" ]
    lappend format [list { "VIAM_LUMFILTER_SHUTTER" "VIAM_LUMFILTER_GAIN" "VIAM_LUMFILTER_SHARPNESS" "VIAM_LUMFILTER_EXPOSURE" "VIAM_LUMFILTER_BRIGHTNESS" } "Filter type" "VIAM_LUMFILTER_BRIGHTNESS" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_SOFTWARE" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter values" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_VALUE_PERCENT" "VIAM_VALUE_ABSOLUTE" "VIAM_VALUE_INVALID" } "Value kind" "VIAM_VALUE_PERCENT" ]
    lappend format [list double "Value" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "PushLumFilter" \
	"Push additional luminance filter" \
	"ViamLumFilter\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| ViamLumFilterType type\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_valuekind_t vkind\n| double parameter\n" \
	7 \
	$format \
	$args ]
}


proc ::viamPushLumFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamPushLumFilter
interp hide {} viamPushLumFilterFormatOutput





# UpdateLumFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamUpdateLumFilter] >= 0 } {
    interp expose {} viamUpdateLumFilter
}
if { [lsearch [interp hidden] viamUpdateLumFilterFormatOutput] >= 0 } {
    interp expose {} viamUpdateLumFilterFormatOutput
}

proc ::viamUpdateLumFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_SOFTWARE" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter values" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_VALUE_PERCENT" "VIAM_VALUE_ABSOLUTE" "VIAM_VALUE_INVALID" } "Value kind" "VIAM_VALUE_PERCENT" ]
    lappend format [list double "Value" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "UpdateLumFilter" \
	"Update existing luminance filter" \
	"ViamULumFilter\n| ViamId\n| | char id\[64\]\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_valuekind_t vkind\n| double parameter\n" \
	5 \
	$format \
	$args ]
}


proc ::viamUpdateLumFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamUpdateLumFilter
interp hide {} viamUpdateLumFilterFormatOutput





# PushColorFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamPushColorFilter] >= 0 } {
    interp expose {} viamPushColorFilter
}
if { [lsearch [interp hidden] viamPushColorFilterFormatOutput] >= 0 } {
    interp expose {} viamPushColorFilterFormatOutput
}

proc ::viamPushColorFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list string "Image name" "" ]
    lappend format [list { "VIAM_COLORFILTER_WHITE_BALANCE" "VIAM_COLORFILTER_TEMPERATURE" "VIAM_COLORFILTER_GAMMA" "VIAM_COLORFILTER_SATURATION" "VIAM_COLORFILTER_HUE" } "Filter type" "VIAM_COLORFILTER_GAMMA" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_OFF" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter algorithm" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_VALUE_PERCENT" "VIAM_VALUE_ABSOLUTE" "VIAM_VALUE_INVALID" } "Value kind" "VIAM_VALUE_PERCENT" ]
    lappend format [list double "Value" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "PushColorFilter" \
	"Push additional color filter" \
	"ViamColorFilter\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| ViamColorFilterType type\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_valuekind_t vkind\n| double parameter\n" \
	7 \
	$format \
	$args ]
}


proc ::viamPushColorFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamPushColorFilter
interp hide {} viamPushColorFilterFormatOutput





# UpdateColorFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamUpdateColorFilter] >= 0 } {
    interp expose {} viamUpdateColorFilter
}
if { [lsearch [interp hidden] viamUpdateColorFilterFormatOutput] >= 0 } {
    interp expose {} viamUpdateColorFilterFormatOutput
}

proc ::viamUpdateColorFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_OFF" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter algorithm" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_VALUE_PERCENT" "VIAM_VALUE_ABSOLUTE" "VIAM_VALUE_INVALID" } "Value kind" "VIAM_VALUE_PERCENT" ]
    lappend format [list double "Value" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "UpdateColorFilter" \
	"Update existing color filter" \
	"ViamUColorFilter\n| ViamId\n| | char id\[64\]\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_valuekind_t vkind\n| double parameter\n" \
	5 \
	$format \
	$args ]
}


proc ::viamUpdateColorFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamUpdateColorFilter
interp hide {} viamUpdateColorFilterFormatOutput





# PushImProcFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamPushImProcFilter] >= 0 } {
    interp expose {} viamPushImProcFilter
}
if { [lsearch [interp hidden] viamPushImProcFilterFormatOutput] >= 0 } {
    interp expose {} viamPushImProcFilterFormatOutput
}

proc ::viamPushImProcFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list string "Image name" "" ]
    lappend format [list { "VIAM_PXFILTER_LOG" } "Filter type" "VIAM_PXFILTER_LOG" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_OFF" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter algorithm" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_VALUE_PERCENT" "VIAM_VALUE_ABSOLUTE" "VIAM_VALUE_INVALID" } "Value kind" "VIAM_VALUE_PERCENT" ]
    lappend format [list double "Specific value" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "PushImProcFilter" \
	"Push additional image processing filter" \
	"ViamPxFilter\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| ViamPxFilterType type\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_valuekind_t vkind\n| double parameter\n" \
	7 \
	$format \
	$args ]
}


proc ::viamPushImProcFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamPushImProcFilter
interp hide {} viamPushImProcFilterFormatOutput





# UpdateImProcFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamUpdateImProcFilter] >= 0 } {
    interp expose {} viamUpdateImProcFilter
}
if { [lsearch [interp hidden] viamUpdateImProcFilterFormatOutput] >= 0 } {
    interp expose {} viamUpdateImProcFilterFormatOutput
}

proc ::viamUpdateImProcFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_OFF" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter algorithm" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_VALUE_PERCENT" "VIAM_VALUE_ABSOLUTE" "VIAM_VALUE_INVALID" } "Value kind" "VIAM_VALUE_PERCENT" ]
    lappend format [list double "Specific value" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "UpdateImProcFilter" \
	"Update existing image processing filter" \
	"ViamUPxFilter\n| ViamId\n| | char id\[64\]\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_valuekind_t vkind\n| double parameter\n" \
	5 \
	$format \
	$args ]
}


proc ::viamUpdateImProcFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamUpdateImProcFilter
interp hide {} viamUpdateImProcFilterFormatOutput





# PushMiscFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamPushMiscFilter] >= 0 } {
    interp expose {} viamPushMiscFilter
}
if { [lsearch [interp hidden] viamPushMiscFilterFormatOutput] >= 0 } {
    interp expose {} viamPushMiscFilterFormatOutput
}

proc ::viamPushMiscFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list string "Image name" "" ]
    lappend format [list { "VIAM_MISCFILTER_TILT" "VIAM_MISCFILTER_PAN" "VIAM_MISCFILTER_FOCUS" "VIAM_MISCFILTER_ZOOM" } "Filter type" "VIAM_MISCFILTER_ZOOM" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_OFF" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter algorithm" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_VALUE_PERCENT" "VIAM_VALUE_ABSOLUTE" "VIAM_VALUE_INVALID" } "Value kind" "VIAM_VALUE_PERCENT" ]
    lappend format [list double "Specific value" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "PushMiscFilter" \
	"Push additional miscelaneous filter" \
	"ViamMiscFilter\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| ViamMiscFilterType type\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_valuekind_t vkind\n| double parameter\n" \
	7 \
	$format \
	$args ]
}


proc ::viamPushMiscFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamPushMiscFilter
interp hide {} viamPushMiscFilterFormatOutput





# UpdateMiscFilter ----------------------------------------------------------

if { [lsearch [interp hidden] viamUpdateMiscFilter] >= 0 } {
    interp expose {} viamUpdateMiscFilter
}
if { [lsearch [interp hidden] viamUpdateMiscFilterFormatOutput] >= 0 } {
    interp expose {} viamUpdateMiscFilterFormatOutput
}

proc ::viamUpdateMiscFilter { name args } {
    set format {}
    lappend format [list string "Filter name" "" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE" "VIAM_FILTER_HARDWARE" "VIAM_FILTER_OFF" "VIAM_FILTER_INVALID" } "Filter mode" "VIAM_FILTER_OFF" ]
    lappend format [list { "VIAM_FILTER_SOFTWARE_ONE_PUSH" "VIAM_FILTER_SOFTWARE_AUTO" "VIAM_FILTER_HARDWARE_ONE_PUSH" "VIAM_FILTER_HARDWARE_AUTO" "VIAM_FILTER_MANUAL" "VIAM_FILTER_AUTOINVALID" } "Filter algorithm" "VIAM_FILTER_MANUAL" ]
    lappend format [list { "VIAM_VALUE_PERCENT" "VIAM_VALUE_ABSOLUTE" "VIAM_VALUE_INVALID" } "Value kind" "VIAM_VALUE_PERCENT" ]
    lappend format [list double "Specific value" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "UpdateMiscFilter" \
	"Update existing miscelaneous filter" \
	"ViamUMiscFilter\n| ViamId\n| | char id\[64\]\n| viam_filtermethod_t method\n| viam_filterautomode_t automode\n| viam_valuekind_t vkind\n| double parameter\n" \
	5 \
	$format \
	$args ]
}


proc ::viamUpdateMiscFilterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamUpdateMiscFilter
interp hide {} viamUpdateMiscFilterFormatOutput





# FilterList ----------------------------------------------------------

if { [lsearch [interp hidden] viamFilterList] >= 0 } {
    interp expose {} viamFilterList
}
if { [lsearch [interp hidden] viamFilterListFormatOutput] >= 0 } {
    interp expose {} viamFilterListFormatOutput
}

proc ::viamFilterList { name args } {
    set format {}
    lappend format [list string "Camera name" "" ]

    return [ ::cs::rqstSend "${name}" "FilterList" \
	"Return a list of available filters" \
	"ViamId\n| char id\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::viamFilterListFormatOutput { list } {
    set format { {} status { } { filterlist { 32 } type } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamFilterList
interp hide {} viamFilterListFormatOutput





# FilterGetCap ----------------------------------------------------------

if { [lsearch [interp hidden] viamFilterGetCap] >= 0 } {
    interp expose {} viamFilterGetCap
}
if { [lsearch [interp hidden] viamFilterGetCapFormatOutput] >= 0 } {
    interp expose {} viamFilterGetCapFormatOutput
}

proc ::viamFilterGetCap { name args } {
    set format {}
    lappend format [list string "Camera name" "" ]
    lappend format [list { "VIAM_FILTER_LOG" "VIAM_FILTER_TILT" "VIAM_FILTER_PAN" "VIAM_FILTER_FOCUS" "VIAM_FILTER_ZOOM" "VIAM_FILTER_TEMPERATURE" "VIAM_FILTER_GAMMA" "VIAM_FILTER_SATURATION" "VIAM_FILTER_HUE" "VIAM_FILTER_WHITE_BALANCE" "VIAM_FILTER_SHUTTER" "VIAM_FILTER_GAIN" "VIAM_FILTER_SHARPNESS" "VIAM_FILTER_EXPOSURE" "VIAM_FILTER_BRIGHTNESS" "VIAM_FILTER_RECTIFY_NN" "VIAM_FILTER_RECTIFY" "VIAM_FILTER_DISTORT_NN" "VIAM_FILTER_DISTORT" "VIAM_FILTER_SCALE" "VIAM_FILTER_SUBSAMPLE" "VIAM_FILTER_FORMAT" "VIAM_FILTER_NONE" } "Filter type" "VIAM_FILTER_NONE" ]

    return [ ::cs::rqstSend "${name}" "FilterGetCap" \
	"Return capabilities of a filter" \
	"ViamFilterGetCap\n| ViamId\n| | char id\[64\]\n| viam_filtertype_t type\n" \
	2 \
	$format \
	$args ]
}


proc ::viamFilterGetCapFormatOutput { list } {
    set format { {} status { } { filtercap { 4 } methods { 6 } automodes } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamFilterGetCap
interp hide {} viamFilterGetCapFormatOutput





# CameraListHWModes ----------------------------------------------------------

if { [lsearch [interp hidden] viamCameraListHWModes] >= 0 } {
    interp expose {} viamCameraListHWModes
}
if { [lsearch [interp hidden] viamCameraListHWModesFormatOutput] >= 0 } {
    interp expose {} viamCameraListHWModesFormatOutput
}

proc ::viamCameraListHWModes { name args } {
    set format {}
    lappend format [list string "Camera name" "" ]
    lappend format [list int "Output modes starting at #offset" 0 ]

    return [ ::cs::rqstSend "${name}" "CameraListHWModes" \
	"Return available modes for a camera" \
	"ViamHWModeListOffset\n| ViamId\n| | char id\[64\]\n| int offset\n" \
	2 \
	$format \
	$args ]
}


proc ::viamCameraListHWModesFormatOutput { list } {
    set format { {} status { } { hwmodes { } count { 32 } { modes { } size { } format { } crop { } fps { } trigger } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamCameraListHWModes
interp hide {} viamCameraListHWModesFormatOutput





# CameraSetHWMode ----------------------------------------------------------

if { [lsearch [interp hidden] viamCameraSetHWMode] >= 0 } {
    interp expose {} viamCameraSetHWMode
}
if { [lsearch [interp hidden] viamCameraSetHWModeFormatOutput] >= 0 } {
    interp expose {} viamCameraSetHWModeFormatOutput
}

proc ::viamCameraSetHWMode { name args } {
    set format {}
    lappend format [list string "Camera name" "" ]
    lappend format [list { "VIAM_HWSZ_1600x1200" "VIAM_HWSZ_1280x960" "VIAM_HWSZ_1024x768" "VIAM_HWSZ_800x600" "VIAM_HWSZ_640x480" "VIAM_HWSZ_512x384" "VIAM_HWSZ_320x240" "VIAM_HWSZ_160x120" "VIAM_HWSZ_INVALID" } "Geometry" "VIAM_HWSZ_1024x768" ]
    lappend format [list { "VIAM_HWFMT_F32" "VIAM_HWFMT_RGB888" "VIAM_HWFMT_YUV444" "VIAM_HWFMT_YVU422_YVYU" "VIAM_HWFMT_YVU422_VYUY" "VIAM_HWFMT_YUV422_YYUV" "VIAM_HWFMT_YUV422_YUYV" "VIAM_HWFMT_YUV422_UYVY" "VIAM_HWFMT_YUV411" "VIAM_HWFMT_MONO16" "VIAM_HWFMT_MONO8" "VIAM_HWFMT_INVALID" } "Format" "VIAM_HWFMT_MONO8" ]
    lappend format [list { "VIAM_HW_CROP" "VIAM_HW_FIXED" } "Sub-window" "VIAM_HW_FIXED" ]
    lappend format [list { "VIAM_HWFPS_FREE" "VIAM_HWFPS_240" "VIAM_HWFPS_120" "VIAM_HWFPS_60" "VIAM_HWFPS_30" "VIAM_HWFPS_15" "VIAM_HWFPS_7_5" "VIAM_HWFPS_3_75" "VIAM_HWFPS_1_875" "VIAM_HWFPS_INVALID" } "Framerate" "VIAM_HWFPS_15" ]
    lappend format [list { "VIAM_HWTRIGGER_MODE1_HIGH" "VIAM_HWTRIGGER_MODE1_LOW" "VIAM_HWTRIGGER_MODE0_LOW" "VIAM_HWTRIGGER_MODE0_HIGH" "VIAM_HWTRIGGER_INTERNAL" "VIAM_HWTRIGGER_INVALID" } "Trigger" "VIAM_HWTRIGGER_INTERNAL" ]

    return [ ::cs::rqstSend "${name}" "CameraSetHWMode" \
	"Set acquisition mode of a camera" \
	"ViamHWMode\n| ViamId\n| | char id\[64\]\n| viam_hwmode_t\n| | viam_hwsize_t size\n| | viam_hwformat_t format\n| | viam_hwcrop_t crop\n| | viam_hwfps_t fps\n| | viam_hwtrigger_t trigger\n" \
	6 \
	$format \
	$args ]
}


proc ::viamCameraSetHWModeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamCameraSetHWMode
interp hide {} viamCameraSetHWModeFormatOutput





# Acquire ----------------------------------------------------------

if { [lsearch [interp hidden] viamAcquire] >= 0 } {
    interp expose {} viamAcquire
}
if { [lsearch [interp hidden] viamAcquireFormatOutput] >= 0 } {
    interp expose {} viamAcquireFormatOutput
}

proc ::viamAcquire { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]
    lappend format [list int "Numer of images, 0 for unlimited" 1 ]

    return [ ::cs::rqstSend "${name}" "Acquire" \
	"Acquire a single image" \
	"ViamAcquire\n| ViamId\n| | char id\[64\]\n| unsigned int n\n" \
	2 \
	$format \
	$args ]
}


proc ::viamAcquireFormatOutput { list } {
    set format { {} status { } { acquire { } { bank { } id } { } n } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamAcquire
interp hide {} viamAcquireFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] viamStop] >= 0 } {
    interp expose {} viamStop
}
if { [lsearch [interp hidden] viamStopFormatOutput] >= 0 } {
    interp expose {} viamStopFormatOutput
}

proc ::viamStop { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stop image acquisition" \
	"ViamId\n| char id\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::viamStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamStop
interp hide {} viamStopFormatOutput





# Display ----------------------------------------------------------

if { [lsearch [interp hidden] viamDisplay] >= 0 } {
    interp expose {} viamDisplay
}
if { [lsearch [interp hidden] viamDisplayFormatOutput] >= 0 } {
    interp expose {} viamDisplayFormatOutput
}

proc ::viamDisplay { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]
    lappend format [list string "Image name" "" ]
    lappend format [list { "VIAM_ON" "VIAM_OFF" } "Enable display" "VIAM_ON" ]
    lappend format [list { "VIAM_ON" "VIAM_OFF" } "Enable display of performance tags" "VIAM_OFF" ]
    lappend format [list int "Window width (0 for auto)" 0 ]
    lappend format [list int "Window height (0 for auto)" 0 ]

    return [ ::cs::rqstSend "${name}" "Display" \
	"Show images on local display" \
	"ViamDisplay\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| viam_onoff_t enable\n| viam_onoff_t vtag\n| int width\n| int height\n" \
	6 \
	$format \
	$args ]
}


proc ::viamDisplayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamDisplay
interp hide {} viamDisplayFormatOutput





# Calibrate ----------------------------------------------------------

if { [lsearch [interp hidden] viamCalibrate] >= 0 } {
    interp expose {} viamCalibrate
}
if { [lsearch [interp hidden] viamCalibrateFormatOutput] >= 0 } {
    interp expose {} viamCalibrateFormatOutput
}

proc ::viamCalibrate { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]
    lappend format [list { "VIAM_CAL_STEREO" "VIAM_CAL_MONO" } "Calibration type" "VIAM_CAL_MONO" ]
    lappend format [list { "VIAM_DIST_R3T2" "VIAM_DIST_R2T2" "VIAM_DIST_R1T2" "VIAM_DIST_R3T0" "VIAM_DIST_R2T0" "VIAM_DIST_R1T0" } "Distortion model" "VIAM_DIST_R3T2" ]
    lappend format [list int "Number of rows on the calibration grid" 7 ]
    lappend format [list int "Number of columns on the calibration grid" 9 ]
    lappend format [list double "Dimension of the squares on the calibration grid" 0.115500 ]
    lappend format [list double "Minimal distance between overlapping chessboards (pixels)" 75.000000 ]
    lappend format [list double "Maximal allowed motion of the chessboard (pixels)" 5.000000 ]
    lappend format [list double "Expected reprojection error (0.0 for unlimited)" 0.050000 ]
    lappend format [list int "Maximum number of images" 25 ]

    return [ ::cs::rqstSend "${name}" "Calibrate" \
	"Camera calibration procedure for a bank" \
	"ViamCalibrate\n| ViamId\n| | char id\[64\]\n| viam_caltype_t type\n| viam_distortionmodel_t dmodel\n| int gridrows\n| int gridcols\n| double gridsize\n| double overlapth\n| double motionth\n| double precision\n| int images\n" \
	10 \
	$format \
	$args ]
}


proc ::viamCalibrateFormatOutput { list } {
    set format { {} status { } precision }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamCalibrate
interp hide {} viamCalibrateFormatOutput





# CalibrationIO ----------------------------------------------------------

if { [lsearch [interp hidden] viamCalibrationIO] >= 0 } {
    interp expose {} viamCalibrationIO
}
if { [lsearch [interp hidden] viamCalibrationIOFormatOutput] >= 0 } {
    interp expose {} viamCalibrationIOFormatOutput
}

proc ::viamCalibrationIO { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]
    lappend format [list { "VIAM_SAVE" "VIAM_LOAD" } "I/O Operation" "VIAM_LOAD" ]
    lappend format [list string "File name to save calibration data" "calibration.data" ]

    return [ ::cs::rqstSend "${name}" "CalibrationIO" \
	"Save or load calibration data for a bank" \
	"ViamCalibrationIO\n| ViamId\n| | char id\[64\]\n| ViamIO op\n| char file\[1024\]\n" \
	3 \
	$format \
	$args ]
}


proc ::viamCalibrationIOFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamCalibrationIO
interp hide {} viamCalibrationIOFormatOutput





# Save ----------------------------------------------------------

if { [lsearch [interp hidden] viamSave] >= 0 } {
    interp expose {} viamSave
}
if { [lsearch [interp hidden] viamSaveFormatOutput] >= 0 } {
    interp expose {} viamSaveFormatOutput
}

proc ::viamSave { name args } {
    set format {}
    lappend format [list string "Bank name" "" ]
    lappend format [list string "Image name" "" ]
    lappend format [list { "VIAM_ON" "VIAM_OFF" } "Enable save" "VIAM_ON" ]
    lappend format [list string "File name pattern (use %d for image number)" "image%04d.ppm" ]

    return [ ::cs::rqstSend "${name}" "Save" \
	"Save images on disk" \
	"ViamSave\n| ViamId\n| | char id\[64\]\n| ViamId\n| | char id\[64\]\n| viam_onoff_t enable\n| char pattern\[1024\]\n" \
	4 \
	$format \
	$args ]
}


proc ::viamSaveFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} viamSave
interp hide {} viamSaveFormatOutput


